VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4410
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   7080
   Height          =   4815
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4410
   ScaleWidth      =   7080
   Top             =   1170
   Width           =   7200
   Begin VB.PictureBox picTemp 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   3000
      ScaleHeight     =   735
      ScaleWidth      =   855
      TabIndex        =   2
      Top             =   3240
      Visible         =   0   'False
      Width           =   855
   End
   Begin VB.PictureBox picCanvas 
      AutoRedraw      =   -1  'True
      Height          =   4200
      Index           =   1
      Left            =   3600
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   4140
      ScaleWidth      =   3330
      TabIndex        =   1
      Top             =   120
      Width           =   3390
   End
   Begin VB.PictureBox picCanvas 
      AutoRedraw      =   -1  'True
      Height          =   4200
      Index           =   0
      Left            =   120
      Picture         =   "Form1.frx":2D072
      ScaleHeight     =   4140
      ScaleWidth      =   3330
      TabIndex        =   0
      Top             =   120
      Width           =   3390
   End
   Begin VB.Menu mnuContext 
      Caption         =   "Context Menu"
      Visible         =   0   'False
      Begin VB.Menu mnuCut 
         Caption         =   "Cu&t"
      End
      Begin VB.Menu mnuCopy 
         Caption         =   "&Copy"
      End
      Begin VB.Menu mnuPaste 
         Caption         =   "&Paste"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Dragging As Boolean
Private X1(0 To 1) As Single
Private Y1(0 To 1) As Single
Private X2(0 To 1) As Single
Private Y2(0 To 1) As Single

Private SelPic As Integer

' Make sure X1 <= X2 and Y1 <= Y2.
Private Sub OrderCorners()
Dim tmp As Single

    If X1(SelPic) > X2(SelPic) Then
        tmp = X1(SelPic)
        X1(SelPic) = X2(SelPic)
        X2(SelPic) = tmp
    End If
    If Y1(SelPic) > Y2(SelPic) Then
        tmp = Y1(SelPic)
        Y1(SelPic) = Y2(SelPic)
        Y2(SelPic) = tmp
    End If
End Sub

' Disable Paste if no image is available.
Private Sub mnuContext_Click()
    mnuPaste.Enabled = Clipboard.GetFormat(vbCFBitmap)
End Sub

' Copy the selected region to the clipboard.
Private Sub mnuCopy_Click()
    ' Make sure X1 <= X2 and Y1 <= Y2.
    OrderCorners

    ' Copy the selected area into picTemp.
    picTemp.Width = X2(SelPic) - X1(SelPic) + 1
    picTemp.Height = Y2(SelPic) - Y1(SelPic) + 1
    picTemp.PaintPicture _
        picCanvas(SelPic).Picture, _
        0, 0, X2(SelPic) - X1(SelPic) + 1, Y2(SelPic) - Y1(SelPic) + 1, _
        X1(SelPic), Y1(SelPic), X2(SelPic) - X1(SelPic) + 1, Y2(SelPic) - Y1(SelPic) + 1
    
    ' Copy to the clipboard.
    Clipboard.Clear
    Clipboard.SetData picTemp.Image, vbCFBitmap
End Sub

Private Sub mnuCut_Click()
    ' Copy the picture to the clipboard.
    mnuCopy_Click
    
    ' Erase this part of the image.
    picCanvas(SelPic).Line _
        (X1(SelPic), Y1(SelPic))-(X2(SelPic), Y2(SelPic)), _
        picCanvas(SelPic).BackColor, BF
End Sub


' Paste whatever is in the clipboard at (X1, Y1).
Private Sub mnuPaste_Click()
    ' Make sure an image exists. This will happen
    ' if the clipboard does not contain a bitmap
    ' and the user presses ^V.
    If Not Clipboard.GetFormat(vbCFBitmap) Then Exit Sub
    
    ' Make sure X1 <= X2 and Y1 <= Y2.
    OrderCorners
    
    picTemp.AutoSize = True
    picTemp.Picture = Clipboard.GetData(vbCFBitmap)
    picTemp.AutoSize = False

    picCanvas(SelPic).PaintPicture _
        picTemp.Picture, _
        X1(SelPic), Y1(SelPic), _
        picTemp.ScaleWidth, picTemp.ScaleHeight, _
        0, 0, picTemp.ScaleWidth, picTemp.ScaleHeight

    ' Make the picture part of the background.
    picCanvas(SelPic).Picture = picCanvas(SelPic).Image
End Sub

Private Sub picCanvas_KeyPress(Index As Integer, KeyAscii As Integer)
    SelPic = Index
    Select Case KeyAscii
        Case 3  ' ^C
            mnuCopy_Click
        Case 22 ' ^V
            mnuPaste_Click
        Case 24 ' ^X
            mnuCut_Click
    End Select
End Sub

Private Sub picCanvas_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button <> vbLeftButton Then Exit Sub
    
    Dragging = True
    picCanvas(Index).DrawMode = vbInvert
    X1(Index) = X
    Y1(Index) = Y
    X2(Index) = X
    Y2(Index) = Y
    picCanvas(Index).Cls
    picCanvas(Index).Line (X, Y)-(X, Y), , B
End Sub

Private Sub picCanvas_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not Dragging Then Exit Sub

    picCanvas(Index).Line (X1(Index), Y1(Index))-(X2(Index), Y2(Index)), , B
    X2(Index) = X
    Y2(Index) = Y
    picCanvas(Index).Line (X1(Index), Y1(Index))-(X2(Index), Y2(Index)), , B
End Sub


' If this is the right button, display the
' context menu.
Private Sub picCanvas_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbRightButton Then
        SelPic = Index
        PopupMenu mnuContext
        Exit Sub
    End If
    
    If Not Dragging Then Exit Sub
    Dragging = False
    picCanvas(Index).DrawMode = vbCopyPen
End Sub
